package de.hdm_stuttgart.mi.sd1;


/**
 * Simplified implementation of {@link Xmas#main(String[])} replacing loops by
 * {@link java.io.PrintStream#format(String, Object...)} and {@link String#repeat(int)}.
 */
public class XmasUsingFormat {

    public static void main(String[] args) {

        // Example: 6 rows, tree's body loop index ranging from 0 to 5

        //           X            The tree's top.
        //  0        *
        //  1       ***
        //  2      *****
        //  3     *******         The tree's body.
        //  4    *********
        //  5   ***********
        //          III           The tree's two bottom trunk lines.
        //          III

        final int numberOfRows = 6;                // You may easily change this value.

        // Part one: The tree's top
        //

        System.out.format("%"+ numberOfRows + "s\n", "X"); // Printing the tree's top.

        // Part two: The tree's body
        //
        for (int row = 0; row < numberOfRows; row++) {    // Outer row per line loop
            System.out.format(
                    "%"+ (numberOfRows + row) + "s\n",     // Printing asterisk(s)
                    "*".repeat(2 * row + 1));
        }

        // Part three: The tree's two bottom trunk lines
        //
        System.out.format("%"+ (numberOfRows + 1) + "s\n", "###");
        System.out.format("%"+ (numberOfRows + 1) + "s\n", "###");
    }
}
